# -*- coding: utf-8 -*-
from TOSSIM import *
from math import*
from tinyos.tossim.TossimApp import *
import random
import sys
import numpy as np 
import matplotlib.pyplot as pl
from matplotlib import cm 

##########
# Create N random nodes
num_of_node = 50;
# Radio range
R = 15;
#Create topology in file topo
topo = open("topo.txt","w");
i=1
while i<=num_of_node:
 j=1
 while j<=num_of_node:
  if(i!=j):topo.write(str(i)+" "+str(j)+"  "+str(random.uniform(-65.0,-55.0))+"\n");
  j=j+1
 i=i+1
topo.close();
# End of topology creation
##########

# Call of TinyOs
n = NescApp();
t = Tossim(n.variables.variables());
t.mac().setMaxIterations(0);
mac = t.mac();
print mac.maxIterations();
r = t.radio();
# Noise defination
noise = open("meyer-heavy.txt", "r")
lines = noise.readlines()
for line in lines:
    string = line.strip()
    if (string != ""):
        val = int(string)
        for i in range(1, num_of_node + 1):
            t.getNode(i).addNoiseTraceReading(-98)
# End of noise defination
##########
noise.close();
# Log file to save our result
log = open("text.log","w");
t.addChannel("sky",log);
eql = open("BestSecond.log","w");
t.addChannel("BestSecond",eql);
i=1
while i<=num_of_node:
 t.getNode(i).createNoiseModel();
 r.setNoise(i, -100.0, 5.0);
 t.getNode(i).bootAtTime(1);
 i=i+1;

for i in range(0, (num_of_node*10)):
  t.runNextEvent();
pl.figure(1)


c=0;
topo = open("topo.txt", "r");
lines = topo.readlines()
for line in lines:
  s = line.split();
  if (len(s) > 0):
    m0 = t.getNode(int(s[0]));
    v = m0.getVariable("Protocole.x")
    #x0 = float(ord(v.getData()[1]))
    x0 = v.getData()
    v = m0.getVariable("Protocole.y")
    y0 = v.getData()
    m1 = t.getNode(int(s[1]));
    v = m1.getVariable("Protocole.x")
    x1 = v.getData()
    v = m1.getVariable("Protocole.y")
    y1 = v.getData()
    if(sqrt((x0-x1)*(x0-x1)+(y0-y1)*(y0-y1)) < R):
       r.add(int(s[0]), int(s[1]), float(s[2]));
       #pl.subplot(211)
       pl.plot([x0, x1], [y0, y1], '0.7');
       #pl.subplot(212)
       pl.plot([x0, x1], [y0, y1], '0.7');
       
  #print x0, y0

for i in range(0, 300000):
  t.runNextEvent();

for i in range(1, num_of_node + 1):
 m0 = t.getNode(i);
 v = m0.getVariable("Protocole.x")
 #x0 = float(ord(v.getData()[1]))
 x0 = v.getData()
 v = m0.getVariable("Protocole.y")
 y0 = v.getData()
 if((x0 == 2 and y0 == 2) or (x0 == 50 and y0 == 50)):
                   	pl.plot(x0, y0,'ro', markersize = 9);
 else:
                   	pl.plot(x0, y0,'bo', markersize = 7);
		   	
 pl.text(x0+1, y0+0.7,"%d"%(m0.getVariable("Protocole.node")).getData(),
          horizontalalignment='center',verticalalignment='center',fontsize=12)
 tr = open("BestSecond.log", "r");
 lines = tr.readlines()
 trace1 = 1
 index = "2"
 while(trace1):
  for line in lines:
   trace = line.split();
   if(trace[2]==index):
    x0 = trace[3] 
    y0 = trace[4] 
    index = trace[5]
    for line in lines:
      trace = line.split();
      if(trace[2]==index):
         x1 = trace[3] 
         y1 = trace[4]
         pl.plot([int(x0),int(x1)],[int(y0),int(y1)],'-.r');
  if(index == "1"): 
    trace1 = 0
    pl.plot([2,int(x1)],[2,int(y1)],'-.r');
	   

route = open("equalHop.log", "r")
lines = route.readlines()
start = 0;
for line in lines:
        string = line.split()
        if(string[2] !="next"):
          if(string[4] =="0"):
		 m0 = t.getNode(int(string[2]));
	         v = m0.getVariable("Protocole.x")
	         #x0 = float(ord(v.getData()[1]))
	         x1 = v.getData() 
		 v = m0.getVariable("Protocole.y")
	         y1 = v.getData()
		 if(start):
		   #pl.plot(x0, y0 ,'ro');
                   #pl.subplot(211)
                   pl.plot(x0, y0,'bo', markersize = 7);
		   pl.plot([x0,x1],[y0,y1],'0.0');
		 x0 = x1;
		 y0 = y1;
		 start = 1;
	  else:
		 m0 = t.getNode(int(string[2]));
	         v = m0.getVariable("Protocole.x")
	         #x0 = float(ord(v.getData()[1]))
	         x1 = v.getData() 
		 v = m0.getVariable("Protocole.y")
	         y1 = v.getData()
		 if(start):
		   #pl.plot(x0, y0 ,'ro');
                   #pl.subplot(212)
		   pl.plot(x0, y0,'bo', markersize = 7);
		   pl.plot([x0+0.05,x1+0.05],[y0,y1],'k--');
		 x0 = x1;
		 y0 = y1;
		 start = 1;

	else: start = 0;



#pl.plot([0,0],[0,0],'g--',label='Feedback routes');
#pl.plot([0,0],[0,0],'r-',label='AODV routes');
#pl.plot([0,0],[0,0],'b:',label='Nodes connection');
#pl.plot([0],[0],'ro',label='Source node');
#pl.plot([0,0],[0,0],'go',label='Destination node');
    
pl.plot(0,0,'')
pl.plot(60,60,'')   
#pl.plot([1,2,3], label="test1") 
pl.legend(bbox_to_anchor=(1.05, 1), loc=1, borderaxespad=0.)
pl.show()
topo.close()
log.close()
eql.close()